---
name: Feature Request
about: If you have a suggestion for some change or new feature, please use this template
  to report it.
title: ''
labels: feature-request
assignees: ''

---

*First of all, make sure that the feature you are proposing doesn't already exist. Delete this line only once you did that.*

["one liner" - concisely describe your feature request with one very brief paragraph, preferably between 1-3 lines, in clear, correct and acceptable English]

**Full Description**
Describe thoroughly what the feature you desire is, why it's useful and why it fits in this package (and not a standalone package for example). Mention what your use case is (what you want to use it for) and how it should be included (what API changes that are necessary, if they are breaking changes, etc). This is mandatory. Please include how it should be implemented as well (is it a new flag to pass through to android/ios, is it just a new method using some build in functions, etc). This last part is optional but highly encouraged. It's super valuable to do some research to help us make sure your idea is doable. This section is mandatory.

**Example Code**
Unless your feature requires no API changes whatsoever, provide a very concise code example of how it would be used in a Flutter app. This is **mandatory** if your feature requires any API changes. You **must** use code blocks to put your code in. You can link an example repo (unnecessary) but you must add a simple version on the issue.

**Platforms**
Make sure to identify for which platforms this must be implemented. By platforms here I mean: android, ios, web, macos, etc. This section is mandatory.

First, assess if this already exists or not on some platforms but not on others. Some stuff we currently only support on Android or only on iOS because Open Source projects are made with the help of the community and we not always have time to do everything. If, for example, you want an iOS feature to be added to android, that is totally fine but specify that here. In this case, provide in the sections above a clear explanation of how it already works on all platforms its present on (e.g. the Code section must include code for how to use it on platform X and what changes (if any, probably none) are necessary on the api level to add it to platform Y).

Secondly, asses in which platforms this make sense to be added. Especially web/macos. There are some features that just don't make sense outside of the mobile world, for example. Not everything needs to be present on all platforms. Please think about which platforms this should be added for, ideally. That doesn't mean we will end up doing all of them to start, but just as the goal.

This is also a perfect section to include, if your prior research already revealed it, if there are minimum OS versions that are absolutely required to add this feature. For example, if it's only possible to do it after Android 23, add that detail here.

**Sample Files/URLs/Sources**
If your feature request involves a new type of file, a different URL, stream type, etc, please provide here any resources that would be required to test or develop your feature. For example, if you wanted to play a different kind of file, please provide such file. This section is optional (only add it if it makes sense).

**Mockups**
If applicable, add mockup screenshots or videos to help to explain what this feature would look like. This is totally optional. It can also be screenshots/screen recordings of existing apps, built using other libraries (like native libraries), to do what you want, or of how it works on other platforms if it already exists on audioplayers on some platforms.

**Research Resources**
During your research for your use case, you might have encountered some existing apps using this feature through other (maybe native) libraries, tutorials explaining how to do it on the native side, articles explaining why this is useful for end users, etc. Add here any links or references that you have to help to make your case for this feature. This is optional but highly encouraged if your feature is anything bigger or more complex.
